
// No need to change anything in this file except for some of the extra
// credit.

// This program takes one argument and creates a C file
// letter_probabilities.c based on that file's contents.

#define _GNU_SOURCE
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#define ALPHABET_SIZE 26

int main(int argc, char**argv) {
  if(argc != 2) {
    fprintf(stderr,"usage: %s file-name",argv[0]);
    exit(1);
  }
  FILE * in = fopen(argv[1],"r");
  if(!in) {
    fprintf(stderr, "unable to open file %s", argv[1]);
    exit(1);
  }
  FILE * out = fopen("letter_probabilities.c","w");
  if(!out) {
    fprintf(stderr, "unable to open file letter_probabilities.c");
    exit(1);
  }
  int counts[ALPHABET_SIZE];
  int total_count=0;
  int i;
  for(i=0; i<ALPHABET_SIZE; ++i)
    counts[i] = 0;
  char *line = NULL;
  size_t len = 0;
  ssize_t read;
  while((read = getline(&line, &len, in)) != -1) {
    for(i=0; i < read; ++i)
      if(isalpha(line[i])) {
	++counts[tolower(line[i])-'a'];
	++total_count;
      }
  }
  double results[ALPHABET_SIZE];
  results[0] = ((double)counts[0])/((double)total_count);
  for(i=1; i<ALPHABET_SIZE; ++i)
    results[i] = results[i-1] + ((double)counts[i])/((double)total_count);
  fprintf(out,"// THIS FILE IS AUTO-GENERATED; DO NOT EDIT\n");
  fprintf(out,"#define ALPHABET_SIZE %d\n",ALPHABET_SIZE);
  fprintf(out,"double letter_probabilities[ALPHABET_SIZE] = {\n");
  for(i=0; i<ALPHABET_SIZE-1; ++i)
    fprintf(out,"  %g, // %c \n",results[i], i+'a');
  fprintf(out,"  1.0 // z\n};\n"); // hard-wired 1.0 avoids any rounding
  fclose(in);
  fclose(out);
  return 0;
}
